package org.dromara.chat.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.chat.domain.ChatMessage;
import org.dromara.chat.domain.bo.ChatMessageBo;
import org.dromara.chat.domain.vo.ChatMessageVo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;

import java.util.Collection;
import java.util.List;

/**
 * 聊天消息Service接口
 *
 * @author pengles
 */
public interface ChatMessageService extends IService<ChatMessage> {

    /**
     * 查询聊天消息
     */
    ChatMessageVo queryById(Long id);

    /**
     * 查询聊天消息列表
     */
    TableDataInfo<ChatMessageVo> queryPageList(ChatMessageBo bo, PageQuery pageQuery);

    /**
     * 查询聊天消息列表
     */
    List<ChatMessageVo> queryList(ChatMessageBo bo);

    /**
     * 新增聊天消息
     */
    Boolean insertByBo(ChatMessageBo bo);

    /**
     * 修改聊天消息
     */
    Boolean updateByBo(ChatMessageBo bo);

    /**
     * 校验并批量删除聊天消息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据会话ID查询消息列表
     */
    List<ChatMessageVo> queryListBySessionId(Long sessionId);

    /**
     * 根据用户ID查询消息列表
     */
    List<ChatMessageVo> queryListByUserId(Long userId);

    /**
     * 根据会话ID和用户ID查询消息列表
     */
    List<ChatMessageVo> queryListBySessionIdAndUserId(Long sessionId, Long userId);

}